Happy new year
[pazpar2-moved-to-github.git] / debian / pazpar2.init
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          pazpar2
4 # Required-Start:    $local_fs $remote_fs $network $named $time
5 # Required-Stop:     $local_fs $remote_fs
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Controls the pazpar2 daemon
9 # Description:       Controls the Pazpar2 Metasearcher daemon
10 #                    /usr/sbin/pazpar2 .
11 ### END INIT INFO
12
13 # Do NOT "set -e"
14
15 # PATH should only include /usr/* if it runs after the mountnfs.sh script
16 PATH=/sbin:/usr/sbin:/bin:/usr/bin
17 NAME=pazpar2
18 DAEMON=/usr/sbin/$NAME
19 DAEMON_OPTS="-h"
20 PIDFILE=/var/run/$NAME.pid
21 SCRIPTNAME=/etc/init.d/$NAME
22
23 # Exit if the package is not installed
24 [ -x "$DAEMON" ] || exit 0
25
26 # Read configuration variable file if it is present
27 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
28
29 # Load the VERBOSE setting and other rcS variables
30 . /lib/init/vars.sh
31
32 # Define LSB log_* functions.
33 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
34 . /lib/lsb/init-functions
35
36 #
37 # Function that starts the daemon/service
38 #
39 do_start()
40 {
41         # Return
42         #   0 if daemon has been started
43         #   1 if daemon was already running
44         #   2 if daemon could not be started
45         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
46                 || return 1
47         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
48                 $DAEMON_OPTS \
49                 || return 2
50         # Add code here, if necessary, that waits for the process to be ready
51         # to handle requests from services started subsequently which depend
52         # on this one.  As a last resort, sleep for some time.
53 }
54
55 #
56 # Function that stops the daemon/service
57 #
58 do_stop()
59 {
60         # Return
61         #   0 if daemon has been stopped
62         #   1 if daemon was already stopped
63         #   2 if daemon could not be stopped
64         #   other if a failure occurred
65         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
66         RETVAL="$?"
67         [ "$RETVAL" = 2 ] && return 2
68         # Wait for children to finish too if this is a daemon that forks
69         # and if the daemon is only ever run from this initscript.
70         # If the above conditions are not satisfied then add some other code
71         # that waits for the process to drop all resources that could be
72         # needed by services started subsequently.  A last resort is to
73         # sleep for some time.
74         #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
75         #[ "$?" = 2 ] && return 2
76         # Many daemons don't delete their pidfiles when they exit.
77         rm -f $PIDFILE
78         return "$RETVAL"
79 }
80
81 #
82 # Function that sends a SIGHUP to the daemon/service
83 #
84 do_reload() {
85         #
86         # If the daemon can reload its configuration without
87         # restarting (for example, when it is sent a SIGHUP),
88         # then implement that here.
89         #
90         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
91         return 0
92 }
93
94 case "$1" in
95   start)
96         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
97         do_start
98         case "$?" in
99                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
100                 2) [ "$VERBOSE" = no ] && \
101                                 log_daemon_msg "Starting $DESC" "$NAME"
102                         log_end_msg 1 
103                 ;;
104         esac
105         ;;
106   stop)
107         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
108         do_stop
109         case "$?" in
110                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
111                 2) [ "$VERBOSE" = no ] && \
112                                 log_daemon_msg "Stopping $DESC" "$NAME"
113                         log_end_msg 1 
114                 ;;
115         esac
116         ;;
117   #reload|force-reload)
118         #
119         # If do_reload() is not implemented then leave this commented out
120         # and leave 'force-reload' as an alias for 'restart'.
121         #
122         #log_daemon_msg "Reloading $DESC" "$NAME"
123         #do_reload
124         #log_end_msg $?
125         #;;
126   restart|force-reload)
127         #
128         # If the "reload" option is implemented then remove the
129         # 'force-reload' alias
130         #
131         log_daemon_msg "Restarting $DESC" "$NAME"
132         do_stop
133         case "$?" in
134           0|1)
135                 do_start
136                 case "$?" in
137                         0) log_end_msg 0 ;;
138                         1) log_end_msg 1 ;; # Old process is still running
139                         *) log_end_msg 1 ;; # Failed to start
140                 esac
141                 ;;
142           *)
143                 # Failed to stop
144                 log_end_msg 1
145                 ;;
146         esac
147         ;;
148   status)
149         status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
150         ;;
151   *)
152         echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
153         exit 3
154         ;;
155 esac
156
157 :